diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java b/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
index 572aa93be..a8455e7a2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
@@ -1,6 +1,15 @@
 package net.minecraft.core.world.biome;
 
-import net.minecraft.core.entity.animal.*;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.entity.SpawnListEntry;
+import net.minecraft.core.entity.animal.MobButterfly;
+import net.minecraft.core.entity.animal.MobChicken;
+import net.minecraft.core.entity.animal.MobCow;
+import net.minecraft.core.entity.animal.MobDeer;
+import net.minecraft.core.entity.animal.MobFireflyCluster;
+import net.minecraft.core.entity.animal.MobPig;
+import net.minecraft.core.entity.animal.MobSheep;
+import net.minecraft.core.entity.animal.MobSquid;
 import net.minecraft.core.entity.monster.MobCreeper;
 import net.minecraft.core.entity.monster.MobSkeleton;
 import net.minecraft.core.entity.monster.MobSlime;
@@ -9,13 +18,15 @@ import net.minecraft.core.entity.monster.MobSpider;
 import net.minecraft.core.entity.monster.MobZombie;
 import net.minecraft.core.entity.monster.MobZombieArmored;
 import net.minecraft.core.enums.MobCategory;
-import net.minecraft.core.block.Blocks;
-import net.minecraft.core.entity.SpawnListEntry;
+import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.weather.Weather;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.ArrayList;
 import java.util.List;
@@ -37,24 +48,24 @@ public class Biome
     
     public Biome(String key)
     {
-    	this.translationKey = "biome." + key; 
-        topBlock = (short) Blocks.GRASS.id();
-        fillerBlock = (short)Blocks.DIRT.id();
-        spawnableMonsterList.add(new SpawnListEntry(MobSpider.class, 10));
-        spawnableMonsterList.add(new SpawnListEntry(MobZombie.class, 10));
-        spawnableMonsterList.add(new SpawnListEntry(MobZombieArmored.class, 2));
-        spawnableMonsterList.add(new SpawnListEntry(MobSkeleton.class, 10));
-        spawnableMonsterList.add(new SpawnListEntry(MobCreeper.class, 10));
-        spawnableMonsterList.add(new SpawnListEntry(MobSlime.class, 10));
-        spawnableMonsterList.add(new SpawnListEntry(MobSnowman.class, 2));
-        spawnableCreatureList.add(new SpawnListEntry(MobSheep.class, 102));
-        spawnableCreatureList.add(new SpawnListEntry(MobPig.class, 102));
-        spawnableCreatureList.add(new SpawnListEntry(MobChicken.class, 102));
-        spawnableCreatureList.add(new SpawnListEntry(MobCow.class, 102));
-        spawnableCreatureList.add(new SpawnListEntry(MobDeer.class, 10));
-        spawnableWaterCreatureList.add(new SpawnListEntry(MobSquid.class, 10));
-        spawnableAmbientCreatureList.add(new SpawnListEntry(MobFireflyCluster.class, 10));
-        spawnableAmbientCreatureList.add(new SpawnListEntry(MobButterfly.class, 65));
+    	this.translationKey = "biome." + key;
+        this.topBlock = (short) Blocks.GRASS.id();
+        this.fillerBlock = (short)Blocks.DIRT.id();
+        this.spawnableMonsterList.add(new SpawnListEntry(MobSpider.class, 10));
+        this.spawnableMonsterList.add(new SpawnListEntry(MobZombie.class, 10));
+        this.spawnableMonsterList.add(new SpawnListEntry(MobZombieArmored.class, 2));
+        this.spawnableMonsterList.add(new SpawnListEntry(MobSkeleton.class, 10));
+        this.spawnableMonsterList.add(new SpawnListEntry(MobCreeper.class, 10));
+        this.spawnableMonsterList.add(new SpawnListEntry(MobSlime.class, 10));
+        this.spawnableMonsterList.add(new SpawnListEntry(MobSnowman.class, 2));
+        this.spawnableCreatureList.add(new SpawnListEntry(MobSheep.class, 102));
+        this.spawnableCreatureList.add(new SpawnListEntry(MobPig.class, 102));
+        this.spawnableCreatureList.add(new SpawnListEntry(MobChicken.class, 102));
+        this.spawnableCreatureList.add(new SpawnListEntry(MobCow.class, 102));
+        this.spawnableCreatureList.add(new SpawnListEntry(MobDeer.class, 10));
+        this.spawnableWaterCreatureList.add(new SpawnListEntry(MobSquid.class, 10));
+        this.spawnableAmbientCreatureList.add(new SpawnListEntry(MobFireflyCluster.class, 10));
+        this.spawnableAmbientCreatureList.add(new SpawnListEntry(MobButterfly.class, 65));
     }
 
     public WorldFeature getRandomWorldGenForTrees(Random random)
@@ -91,16 +102,16 @@ public class Biome
     public @NotNull List<@NotNull SpawnListEntry> getSpawnableList(final @NotNull MobCategory creatureType)
     {
         return switch (creatureType) {
-            case MONSTER -> spawnableMonsterList;
-            case CREATURE -> spawnableCreatureList;
-            case WATER_CREATURE -> spawnableWaterCreatureList;
-            case AMBIENT -> spawnableAmbientCreatureList;
+            case MONSTER -> this.spawnableMonsterList;
+            case CREATURE -> this.spawnableCreatureList;
+            case WATER_CREATURE -> this.spawnableWaterCreatureList;
+            case AMBIENT -> this.spawnableAmbientCreatureList;
         };
     }
     
     public boolean hasSurfaceSnow()
     {
-    	return hasSurfaceSnow;
+    	return this.hasSurfaceSnow;
     }
 
     public boolean hasSurfaceIce() {
@@ -109,7 +120,7 @@ public class Biome
 
     public Biome setSurfaceSnow()
     {
-    	hasSurfaceSnow = true;
+        this.hasSurfaceSnow = true;
     	return this;
     }
 
@@ -135,4 +146,35 @@ public class Biome
         this.fillerBlock = (short)id;
         return this;
     }
+
+    public static @Nullable TilePosc getBiomeCoords(@NotNull Biome biome, @NotNull World world) {
+        int[] xPattern = new int[]{0, 1, 0, -1};
+        int[] zPattern = new int[]{1, 0, -1, 0};
+        TilePosc sourcePos = new TilePos();
+        int runLength = 2;
+        int chunkX = (int) (sourcePos.x() / 16.0);
+        int chunkZ = (int) (sourcePos.z() / 16.0);
+        int passes = 1024;
+        if (world.getBiomeProvider().getBiome(sourcePos.x(), sourcePos.y(), sourcePos.z()) == biome) {
+            return sourcePos;
+        } else {
+            --chunkX;
+            --chunkZ;
+            for (int pass = 0; pass < passes; ++pass) {
+                for (int i = 0; i < 4; ++i) {
+                    for (int j = runLength - 1; j >= 0; --j) {
+                        chunkX += xPattern[i];
+                        chunkZ += zPattern[i];
+                        if (world.getBiomeProvider().getBiome(chunkX * 16, sourcePos.y(), chunkZ * 16) == biome) {
+                            return new TilePos(chunkX * 16, sourcePos.y(), chunkZ * 16);
+                        }
+                    }
+                }
+
+                ++runLength;
+            }
+
+            return null;
+        }
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/data/BiomeRangeMap.java b/game/core/src/main/java/net/minecraft/core/world/biome/data/BiomeRangeMap.java
index 0ccdd749e..df60a6eac 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/data/BiomeRangeMap.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/data/BiomeRangeMap.java
@@ -19,7 +19,7 @@ public final class BiomeRangeMap
 
     public void addRange(Biome biome, BiomeRange... ranges)
     {
-        if (ranges == null || ranges.length == 0 || lookup != null) return;
+        if (ranges == null || ranges.length == 0 || this.lookup != null) return;
         Set<BiomeRange> set = this.ranges.getOrDefault(biome, new HashSet<>());
         set.addAll(Arrays.asList(ranges));
         this.ranges.put(biome, set);
@@ -27,7 +27,7 @@ public final class BiomeRangeMap
 
     public void lock()
     {
-        lookup = new BiomeRangeLookup(this, 50);
+        this.lookup = new BiomeRangeLookup(this, 50);
     }
 
     public Set<BiomeRange> getRanges(Biome biome)
@@ -38,9 +38,13 @@ public final class BiomeRangeMap
         return Collections.unmodifiableSet(ranges);
     }
 
+    public Set<Biome> allBiomes() {
+        return this.ranges.keySet();
+    }
+
     public void clear() {
-        lookup = null;
-        ranges.clear();
+        this.lookup = null;
+        this.ranges.clear();
     }
 
     public boolean hasGaps()
@@ -73,7 +77,7 @@ public final class BiomeRangeMap
         altitude = MathHelper.clamp(altitude, 0.0, 1.0);
         variety = MathHelper.clamp(variety, 0.0, 1.0);
 
-        return lookup.getBiome(temperature, humidity, altitude, variety);
+        return this.lookup.getBiome(temperature, humidity, altitude, variety);
     }
 
     Biome findBiome(double temperature, double humidity, double altitude, double variety)
@@ -84,7 +88,7 @@ public final class BiomeRangeMap
         variety = MathHelper.clamp(variety, 0.0, 1.0);
         Biome last = null;
 
-        for (Map.Entry<Biome, Set<BiomeRange>> entry : ranges.entrySet())
+        for (Map.Entry<Biome, Set<BiomeRange>> entry : this.ranges.entrySet())
         {
             for (BiomeRange range : entry.getValue())
             {
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderB173.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderB173.java
index 65960f0a0..6d95fd3a7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderB173.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderB173.java
@@ -3,8 +3,6 @@ package net.minecraft.core.world.biome.provider;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.noise.FractalNoise2D;
-import net.minecraft.core.world.noise.FractalNoise3D;
-import net.minecraft.core.world.noise.Noise2D;
 import net.minecraft.core.world.noise.SimplexNoise;
 import org.jetbrains.annotations.NotNull;
 
@@ -174,4 +172,12 @@ public class BiomeProviderB173
             return humidity < 0.9 ? Biomes.OVERWORLD_LEGACY_SEASONAL_FOREST : Biomes.OVERWORLD_LEGACY_RAINFOREST;
         }
     }
+
+    public static Biome[] allBiomes() {
+        return new Biome[] {
+            Biomes.OVERWORLD_LEGACY_TUNDRA, Biomes.OVERWORLD_LEGACY_SAVANNA, Biomes.OVERWORLD_LEGACY_DESERT, Biomes.OVERWORLD_LEGACY_SWAMPLAND,
+            Biomes.OVERWORLD_LEGACY_TAIGA, Biomes.OVERWORLD_LEGACY_SHRUBLAND, Biomes.OVERWORLD_LEGACY_FOREST, Biomes.OVERWORLD_LEGACY_SEASONAL_FOREST,
+            Biomes.OVERWORLD_LEGACY_RAINFOREST
+        };
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
index 9491a3120..0d03b4adb 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
@@ -277,4 +277,8 @@ public final class BiomeProviderNether
         toUpdate.biomeAPercentage = 1.0f;
         return;
     }
+
+    public static Biome[] allBiomes() {
+        return biomesOrder;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
index fafc504cd..b71fd7301 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
@@ -6,9 +6,7 @@ import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.biome.data.BiomeRange;
 import net.minecraft.core.world.biome.data.BiomeRangeMap;
 import net.minecraft.core.world.noise.FractalNoise2D;
-import net.minecraft.core.world.noise.FractalNoise3D;
 import net.minecraft.core.world.noise.SimplexNoise;
-import net.minecraft.core.world.noise.WorleyNoise;
 import net.minecraft.core.world.type.WorldType;
 
 import java.util.Set;
@@ -17,6 +15,7 @@ public final class BiomeProviderOverworld
     extends BiomeProvider
 {
     private static final BiomeRangeMap brm = new BiomeRangeMap();
+    private static Biome[] biomes;
 
     private final FractalNoise2D<?> temperatureMap;
     private final FractalNoise2D<?> humidityMap;
@@ -398,10 +397,21 @@ public final class BiomeProviderOverworld
                 new BiomeRange(0.95, 1.0, 0.85, 1.0, 0.0, 1.0, 0.0, 1.0)
         );
         brm.lock();
+
+        var allBiomes = brm.allBiomes();
+        biomes = new Biome[allBiomes.size()];
+        int i = 0;
+        for (var biome : allBiomes) {
+            biomes[i++] = biome;
+        }
         
 //		Stop turning this on it crashes servers
 //        if (!Global.isServer){
 //            brm.generateDebugImage(true);
 //        }
     }
+
+    public static Biome[] allBiomes() {
+        return biomes;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index ac9ff06ab..6b2860e00 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -703,6 +703,14 @@ public class Chunk {
         }
     }
 
+    public <T extends Entity> void getEntitiesWithinRadius(@NotNull Class<T> ofClass, double x, double y, double z, double radius, @NotNull List<@NotNull T> entities) {
+        int minSection = Math.max(0, MathHelper.floor((y - radius - 2D) / 16D));
+        int maxSection = Math.min(MathHelper.floor((y + radius + 2D) / 16D), CHUNK_SECTIONS - 1);
+        for (int section = minSection; section <= maxSection; section++) {
+            getSection(section).getEntitiesWithinRadius(ofClass, x, y, z, radius, entities);
+        }
+    }
+
     public boolean needsSaving(boolean saveImmediately) {
         if (this.neverSave) {
             return false;
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
index 4fe64ebe8..037998bc3 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
@@ -255,6 +255,15 @@ public class ChunkSection {
         }
     }
 
+    public <T extends Entity> void getEntitiesWithinRadius(@NotNull Class<T> ofClass, double x, double y, double z, double radius, @NotNull List<@NotNull T> entities) {
+        for (Entity e : this.entities) {
+            if (ofClass.isAssignableFrom(e.getClass()) && e.bb.intersectsSphere(x, y, z, radius)) {
+                //noinspection unchecked
+                entities.add((T) e);
+            }
+        }
+    }
+
     public void onLoad(World world) {
         world.addLoadedEntities(this.entities);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java b/game/core/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java
index ca50a4c41..15b9f388b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java
+++ b/game/core/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java
@@ -7,6 +7,7 @@ import com.mojang.nbt.tags.Tag;
 import net.minecraft.core.util.HardIllegalArgumentException;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
 import java.util.Collection;
@@ -15,55 +16,63 @@ import java.util.Map;
 
 public class SpawnerConfig {
     private static final Logger LOGGER = LogUtils.getLogger();
-    private boolean allowPassive = true;
-    private boolean allowHostile = true;
+    public boolean allowPassive = true;
+    public boolean allowHostile = true;
     private final Map<NamespaceID, Boolean> mobSpawnOverrides = new HashMap<>();
 
-    public boolean canPassiveSpawn(World world) {
-        return allowPassive;
+    public boolean canPassiveSpawn(@NotNull World world) {
+        return this.allowPassive;
     }
 
     public void setPassiveSpawning(boolean flag) {
-        allowPassive = flag;
+        this.allowPassive = flag;
     }
 
-    public boolean canHostileSpawn(World world) {
-        return allowHostile && world.getDifficulty().canHostileMobsSpawn();
+    public boolean canHostileSpawn(@NotNull World world) {
+        return this.allowHostile && world.getDifficulty().canHostileMobsSpawn();
     }
 
     public void setHostileSpawning(boolean flag) {
-        allowHostile = flag;
+        this.allowHostile = flag;
     }
 
-    public boolean canMobSpawn(NamespaceID mobID) {
-        return mobSpawnOverrides.getOrDefault(mobID, true);
+    public boolean canMobSpawn(@NotNull NamespaceID mobID) {
+        return this.mobSpawnOverrides.getOrDefault(mobID, true);
     }
 
-    public void setMobSpawn(NamespaceID mobID, boolean flag) {
-        mobSpawnOverrides.put(mobID, flag);
+    public void setMobSpawn(@NotNull NamespaceID mobID, boolean flag) {
+        this.mobSpawnOverrides.put(mobID, flag);
+    }
+
+    public void set(@NotNull SpawnerConfig config) {
+        this.mobSpawnOverrides.clear();
+        this.mobSpawnOverrides.putAll(config.mobSpawnOverrides);
+
+        this.allowHostile = config.allowHostile;
+        this.allowPassive = config.allowPassive;
     }
 
     public Collection<Map.Entry<NamespaceID, Boolean>> getSpawnEntries() {
-        return mobSpawnOverrides.entrySet();
+        return this.mobSpawnOverrides.entrySet();
     }
 
     public void writeToTag(CompoundTag tag) {
-        tag.putBoolean("passive", allowPassive);
-        tag.putBoolean("hostile", allowHostile);
+        tag.putBoolean("passive", this.allowPassive);
+        tag.putBoolean("hostile", this.allowHostile);
         CompoundTag overridesTag = new CompoundTag();
-        for (Map.Entry<NamespaceID, Boolean> e : mobSpawnOverrides.entrySet()) {
+        for (Map.Entry<NamespaceID, Boolean> e : this.mobSpawnOverrides.entrySet()) {
             overridesTag.putBoolean(e.getKey().toString(), e.getValue());
         }
         tag.putCompound("overrides", overridesTag);
     }
 
     public void readFromTag(CompoundTag tag) {
-        allowPassive = tag.getBoolean("passive");
-        allowHostile = tag.getBoolean("hostile");
+        this.allowPassive = tag.getBoolean("passive");
+        this.allowHostile = tag.getBoolean("hostile");
         CompoundTag overrides = tag.getCompound("overrides");
         for (Map.Entry<String, Tag<?>> tagEntry : overrides.getValue().entrySet()) {
             try {
-                mobSpawnOverrides.put(NamespaceID.fromPool(tagEntry.getKey()).copyUnpooled(), ((ByteTag)tagEntry.getValue()).getValue() != 0);
+                this.mobSpawnOverrides.put(NamespaceID.fromPool(tagEntry.getKey()).copyUnpooled(), ((ByteTag)tagEntry.getValue()).getValue() != 0);
             } catch (HardIllegalArgumentException e) {
                 LOGGER.error("Failed to convert string '{}' to namespace id!", tagEntry.getKey(), e);
             }
diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/TilePos.java b/game/core/src/main/java/net/minecraft/core/world/pos/TilePos.java
index 9822b05e3..b6b2f5a2e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pos/TilePos.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/TilePos.java
@@ -249,7 +249,7 @@ public final class TilePos implements Externalizable, Cloneable, TilePosc {
                 this.y >= 0 &&
                 this.z >= World.MIN_BLOCK_Z &&
                 this.x <= World.MAX_BLOCK_X &&
-                this.y <= source.getHeightBlocks() &&
+                this.y < source.getHeightBlocks() &&
                 this.z <= World.MAX_BLOCK_Z;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/WorldConfiguration.java b/game/core/src/main/java/net/minecraft/core/world/settings/WorldConfiguration.java
index a6c0f008d..c3f680d41 100644
--- a/game/core/src/main/java/net/minecraft/core/world/settings/WorldConfiguration.java
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/WorldConfiguration.java
@@ -6,9 +6,12 @@ import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.config.spawning.SpawnerConfig;
 import net.minecraft.core.world.save.ISaveFormat;
 import net.minecraft.core.world.type.WorldTypeGroups;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -19,7 +22,9 @@ public class WorldConfiguration {
     private boolean cheatsEnabled = false;
     private @NotNull Gamemode gamemode = Gamemodes.SURVIVAL;
     private @NotNull WorldTypeGroups.Group worldTypeGroup = WorldTypeGroups.DEFAULT;
+    private @Nullable Biome startingBiome = null;
     private final @NotNull GameRuleCollection gameRuleCollection = new GameRuleCollection();
+    private final SpawnerConfig spawnerConfig = new SpawnerConfig();
 
     public WorldConfiguration() {
     }
@@ -101,6 +106,18 @@ public class WorldConfiguration {
         return this.gameRuleCollection;
     }
 
+    public @NotNull SpawnerConfig getSpawnerConfig() {
+        return this.spawnerConfig;
+    }
+
+    public void setStartingBiome(@Nullable Biome biome) {
+        this.startingBiome = biome;
+    }
+
+    public @Nullable Biome getStartingBiome() {
+        return this.startingBiome;
+    }
+
     public @NotNull String getFolderName(final @NotNull ISaveFormat saveFormat) {
         final char @NotNull [] ac = ChatAllowedCharacters.ALLOWED_CHARACTERS_ARRAY;
         @NotNull String folderName = this.worldName.trim();
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
index 0b8a7f2f2..5dba29a81 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
@@ -3,9 +3,12 @@ package net.minecraft.core.world.type;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
 import net.minecraft.core.world.config.season.SeasonConfig;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.save.LevelData;
 import net.minecraft.core.world.season.Seasons;
 import net.minecraft.core.world.weather.Weather;
@@ -140,33 +143,67 @@ public abstract class WorldType {
 
     public abstract BiomeProvider createBiomeProvider(World world);
 
+    public abstract @NotNull Biome @NotNull [] allBiomes();
+
     public abstract ChunkGenerator createChunkGenerator(World world);
 
     public abstract boolean isValidSpawn(World world, int x, int y, int z);
 
-    public void getInitialSpawnLocation(World world) {
-        int x = 0;
-        int y = 0;
-        int z = 0;
+    public void getInitialSpawnLocation(World world, @Nullable Biome startingBiome) {
+        TilePos queryPos = new TilePos();
+        TilePos spawnPos = new TilePos();
+        if (startingBiome != null) {
+            TilePosc biomePos = Biome.getBiomeCoords(startingBiome, world);
+            if (biomePos != null) {
+                spawnPos.x = biomePos.x();
+                spawnPos.z = biomePos.z();
+            }
+            Random random = new Random(world.getRandomSeed());
+            int attemptsRemaining = 10000;
+            boolean found = false;
+            while (true) {
+                if (attemptsRemaining <= 0) {
+                    spawnPos.x = 0;
+                    spawnPos.z = 0;
+                    spawnPos.y = world.getHeightValue(spawnPos.x, spawnPos.z) - 1;
+                    break;
+                }
+                spawnPos.x += random.nextInt(64) - random.nextInt(64);
+                spawnPos.z += random.nextInt(64) - random.nextInt(64);
+                spawnPos.y = world.getHeightValue(spawnPos.x, spawnPos.z) - 1;
+                if (world.getBiomeProvider().getBiome(spawnPos.x, spawnPos.y, spawnPos.z) != startingBiome) continue;
+                Block<?> b = world.getBlockType(spawnPos.up(queryPos));
+                if (b.getCollisionAABB(world, queryPos) == null && !b.getMaterial().isLiquid() && world.isBlockOpaqueCube(spawnPos)) {
+                    found = true;
+                    break;
+                }
+                attemptsRemaining--;
+            }
+            if (found) {
+                world.getLevelData().setSpawn(spawnPos.x, spawnPos.y, spawnPos.z);
+                return;
+            }
+        }
         Random random = new Random(world.getRandomSeed());
         int attemptsRemaining = 10000;
         spawnLoop:  while (true) {
             if (attemptsRemaining <= 0) {
-                x = 0;
-                z = 0;
-                y = world.getHeightValue(x, z);
+                spawnPos.x = 0;
+                spawnPos.z = 0;
+                spawnPos.y = world.getHeightValue(spawnPos.x, spawnPos.z) - 1;
                 break spawnLoop;
             }
-            x += random.nextInt(64) - random.nextInt(64);
-            z += random.nextInt(64) - random.nextInt(64);
-            for (y = getMaxY(); y >= getMinY(); y--) {
-                if (world.getBlockId(x, y + 1, z) == 0 && isValidSpawn(world, x, y, z)) {
+            spawnPos.x += random.nextInt(64) - random.nextInt(64);
+            spawnPos.z += random.nextInt(64) - random.nextInt(64);
+            for (spawnPos.y = getMaxY(); spawnPos.y >= getMinY(); spawnPos.y--) {
+                Block<?> b = world.getBlockType(spawnPos.up(queryPos));
+                if (b.getCollisionAABB(world, queryPos) == null && !b.getMaterial().isLiquid() && isValidSpawn(world, spawnPos.x, spawnPos.y, spawnPos.z)) {
                     break spawnLoop;
                 }
             }
             attemptsRemaining--;
         }
-        world.getLevelData().setSpawn(x, y, z);
+        world.getLevelData().setSpawn(spawnPos.x, spawnPos.y, spawnPos.z);
     }
 
     public void getRespawnLocation(World world) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeDebug.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeDebug.java
index 2f97744f3..f367fd9b8 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeDebug.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeDebug.java
@@ -1,11 +1,14 @@
 package net.minecraft.core.world.type;
 
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
 import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.debug.ChunkGeneratorDebug;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Arrays;
 
@@ -26,6 +29,11 @@ public class WorldTypeDebug
         return new BiomeProviderSingleBiome(Biomes.OVERWORLD_PLAINS, 1.0, 1.0, 1.0);
     }
 
+    @Override
+    public @NotNull Biome @NotNull [] allBiomes() {
+        return new Biome[] { Biomes.OVERWORLD_PLAINS };
+    }
+
     @Override
     public ChunkGenerator createChunkGenerator(World world) {
         return new ChunkGeneratorDebug(world);
@@ -37,7 +45,7 @@ public class WorldTypeDebug
     }
 
     @Override
-    public void getInitialSpawnLocation(World world) {
+    public void getInitialSpawnLocation(World world, @Nullable Biome startingBiome) {
         world.getLevelData().setSpawn(0, 1, 0);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeEmpty.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeEmpty.java
index 5636a9aae..8c4fedf23 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeEmpty.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeEmpty.java
@@ -2,12 +2,15 @@ package net.minecraft.core.world.type;
 
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
 import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.empty.ChunkGeneratorEmpty;
 import net.minecraft.core.world.weather.Weather;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class WorldTypeEmpty
         extends WorldType {
@@ -31,6 +34,11 @@ public class WorldTypeEmpty
         return new BiomeProviderSingleBiome(Biomes.OVERWORLD_PLAINS, 1.0, 1.0, 1.0);
     }
 
+    @Override
+    public @NotNull Biome @NotNull [] allBiomes() {
+        return new Biome[] {Biomes.OVERWORLD_PLAINS } ;
+    }
+
     @Override
     public ChunkGenerator createChunkGenerator(World world) {
         return new ChunkGeneratorEmpty(world);
@@ -42,7 +50,7 @@ public class WorldTypeEmpty
     }
 
     @Override
-    public void getInitialSpawnLocation(World world) {
+    public void getInitialSpawnLocation(World world, @Nullable Biome startingBiome) {
         world.getLevelData().setSpawn(0, 1, 0);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/drift/WorldTypeDrift.java b/game/core/src/main/java/net/minecraft/core/world/type/drift/WorldTypeDrift.java
index f51eb13b0..c1e850d2f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/drift/WorldTypeDrift.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/drift/WorldTypeDrift.java
@@ -4,6 +4,7 @@ import net.minecraft.core.Global;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
 import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
@@ -12,6 +13,7 @@ import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.drift.ChunkGeneratorDrift;
 import net.minecraft.core.world.season.Seasons;
 import net.minecraft.core.world.type.WorldType;
+import org.jetbrains.annotations.NotNull;
 
 public class WorldTypeDrift
         extends WorldType {
@@ -55,6 +57,11 @@ public class WorldTypeDrift
         return new BiomeProviderSingleBiome(Biomes.DRIFT_DRIFT, 0.5, 0.0, 0.0);
     }
 
+    @Override
+    public @NotNull Biome @NotNull [] allBiomes() {
+        return new Biome[] { Biomes.DRIFT_DRIFT };
+    }
+
     @Override
     public ChunkGenerator createChunkGenerator(World world) {
         return new ChunkGeneratorDrift(world);
